<?php
/**
 * @filename DefaultLexer.php
 * @author Jerry Yan <792602257@qq.com>
 * @date 2021/3/17 11:56
 */


namespace JerryYan\DSL\Lexer;


use JerryYan\DSL\Token\{
    Token,
    TokenCurry,
    TokenDefine,
    TokenFake,
    TokenLogicAnd,
    TokenLogicEqual,
    TokenLogicFake,
    TokenLogicGreater,
    TokenLogicLess,
    TokenLogicNot,
    TokenLogicNotEqual,
    TokenLogicOr,
    TokenNumber,
    TokenUseVariable,
    TokenVariable
};

class DefaultLexer implements LexerInterface
{
    protected $tokens = [
        Token::FAKE => TokenFake::class,
        Token::CURRY => TokenCurry::class,
        Token::LOGIC_AND => TokenLogicAnd::class,
        Token::LOGIC_OR => TokenLogicOr::class,
        Token::LOGIC_NOT => TokenLogicNot::class,
        Token::LOGIC_EQUAL => TokenLogicEqual::class,
        Token::LOGIC_NOT_EQUAL => TokenLogicNotEqual::class,
        Token::LOGIC_GREATER => TokenLogicGreater::class,
        Token::LOGIC_LESS => TokenLogicLess::class,
        Token::LOGIC_FAKE => TokenLogicFake::class,
        Token::VARIABLE => TokenVariable::class,
        Token::NUMBER => TokenNumber::class,
        Token::DEFINE => TokenDefine::class,
        Token::USE_VARIABLE => TokenUseVariable::class,
    ];

    protected $undefinedTokenType = TokenVariable::class;

    /**
     * @inheritDoc
     */
    public function getTokenTypes(): array
    {
        return $this->tokens;
    }

    /**
     * @inheritDoc
     */
    public function getUndefinedTokenType(): string
    {
        return $this->undefinedTokenType;
    }

}
