<?php
/**
 * @filename FileReader.php
 * @author Jerry Yan <792602257@qq.com>
 * @date 2020/12/17 14:58
 */


namespace JerryYan\DSL\Reader;


use JerryYan\DSL\Exception\FileNotFoundException;

class FileReader extends StringReader
{
    /**
     * FileReader constructor.
     * @param string $fileName 文件名
     * @throws FileNotFoundException 文件不存在时报错
     * @author Jerry Yan <792602257@qq.com>
     * @date 2021/1/26 13:52
     */
    public function __construct(string $fileName)
    {
        if (!file_exists($fileName)) throw new FileNotFoundException;
        $content = file_get_contents($fileName);
        parent::__construct($content);
    }

}